<?php

/**
 * inf_ejecucion_ep actions.
 *
 * @package    contratacion
 * @subpackage inf_ejecucion_ep
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_ejecucion_epActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.modalidad';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */



            /*
             * Variables opcionales
             */



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            $id_anhos = $request['id_anhos'];
            
            $whereAbogado ="";
            $whereArea="";
            $whereEstadoProceso="";
            $whereModalidad="";
            $whereProceso="";
            $whereResponsable="";
            $whereSupervisor="";


            if (isset($request['id_abogado'])) {
                $whereAbogado = " AND tab0.id_abogado=" . $request['id_abogado'];
            }
            
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area=" . $request['id_area'];
            }
            
            if (isset($request['estado_proceso'])) {
                $whereEstadoProceso = " AND tab0.estado_proceso=" . $request['estado_proceso'];
            }
            
            if (isset($request['id_modalidad_sel'])) {
                $whereModalidad = " AND tab0.id_modalidad_sel=" . $request['id_modalidad_sel'];
            }
            
            if (isset($request['no_proceso'])) {
                $whereProceso = " AND tab0.no_proceso=" . $request['no_proceso'];
            }
            
            if (isset($request['responsable'])) {
                $whereResponsable = " AND tab0.responsable=" . $request['responsable'];
            }
            
            if (isset($request['id_supervisor'])) {
                $whereSupervisor = " AND tab0.id_supervisor=" . $request['id_supervisor'];
            }

            


            /*
             * 
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select tab0.*

from(
select tab0.*,tab7.cdps,
tab1.FECHA_APRUEBA AS APRUEBA_ABOGADO,
tab2.FECHA_APRUEBA AS APRUEBA_COMITE,
tab4.no_contrato,tab4.COMPLETO_CONTRA,tab4.valor as VALOR_CONTRATO,
tab5.fecha_inicio,tab5.FECHA_TERMINACION,tab5.FECHA_APRUEBA_POLIZA,
tab6.RP,tab6.FECHA as FECHA_RP,
case
when tab5.id_legaliza_contrato is not null then 'Contrato Legalizado'
when tab4.id_contrato is not null then 'Con Contrato'
when tab3.id_seleccion_ep is not null then 'Proceso de Seleccion'
when tab0.activo = 0 then 'Cerrado'
when tab2.id_aprueba_comite is not null then 'Aprobado por Comite'
when tab1.id_aprueba_ep is not null then 'Aprobado por Abogado'
when tab0.version >=1 and tab0.id_abogado is not null then 'Con Reparto'
when tab0.version >=1 and tab0.id_abogado is null then 'Pendiente de Reparto'
when tab0.version = 0 then 'Version Inicial'

end AS DESC_ESTADO,

case
when tab5.id_legaliza_contrato is not null then 1
when tab4.id_contrato is not null then 2
when tab3.id_seleccion_ep is not null then 3
when tab0.activo = 0 then 4
when tab2.id_aprueba_comite is not null then 5
when tab1.id_aprueba_ep is not null then 6
when tab0.version >=1 and tab0.id_abogado is not null then 7
when tab0.version >=1 and tab0.id_abogado is null then 8
when tab0.version = 0 then 9

end AS ESTADO_PROCESO

from co_estudios_previos_v tab0
left join co_aprueba_ep tab1 ON tab1.id_estudios_previos = tab0.id_estudios_previos
left join co_aprueba_comite tab2 ON tab2.id_estudios_previos = tab0.id_estudios_previos
left join co_seleccion_ep tab3 ON tab3.id_estudios_previos = tab0.id_estudios_previos
left join co_contrato_v tab4 ON tab4.ID_SELECCION_EP = tab3.ID_SELECCION_EP
left join co_legaliza_contrato tab5 ON tab5.id_contrato = tab4.id_contrato
left join RPS_V tab6 ON tab6.ID = tab5.ID_RP

LEFT JOIN(
select tab0.ID_ESTUDIOS_PREVIOS, listagg(tab1.CDP,', ') within group( order by tab1.CDP ) AS CDPS
from CO_CDPS_EP tab0
left join CO_CDPS_V tab1 ON tab1.id = tab0.ID_CDP
group by tab0.ID_ESTUDIOS_PREVIOS

)tab7 ON tab7.id_estudios_previos = tab0.id_estudios_previos

)tab0

where tab0.id_anhos = $id_anhos and tab0.estado = 1
$whereAbogado
$whereArea
$whereEstadoProceso
$whereModalidad
$whereProceso
$whereResponsable
$whereSupervisor

order by tab0.MODALIDAD,tab0.PROCESO,tab0.version

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*

from(
select tab0.*,tab7.cdps,
tab1.FECHA_APRUEBA AS APRUEBA_ABOGADO,
tab2.FECHA_APRUEBA AS APRUEBA_COMITE,
tab4.no_contrato,tab4.COMPLETO_CONTRA,tab4.valor as VALOR_CONTRATO,
tab5.fecha_inicio,tab5.FECHA_TERMINACION,tab5.FECHA_APRUEBA_POLIZA,
tab6.RP,tab6.FECHA as FECHA_RP,
case
when tab5.id_legaliza_contrato is not null then 'Contrato Legalizado'
when tab4.id_contrato is not null then 'Con Contrato'
when tab3.id_seleccion_ep is not null then 'Proceso de Seleccion'
when tab0.activo = 0 then 'Cerrado'
when tab2.id_aprueba_comite is not null then 'Aprobado por Comite'
when tab1.id_aprueba_ep is not null then 'Aprobado por Abogado'
when tab0.version >=1 and tab0.id_abogado is not null then 'Con Reparto'
when tab0.version >=1 and tab0.id_abogado is null then 'Pendiente de Reparto'
when tab0.version = 0 then 'Version Inicial'

end AS DESC_ESTADO,

case
when tab5.id_legaliza_contrato is not null then 1
when tab4.id_contrato is not null then 2
when tab3.id_seleccion_ep is not null then 3
when tab0.activo = 0 then 4
when tab2.id_aprueba_comite is not null then 5
when tab1.id_aprueba_ep is not null then 6
when tab0.version >=1 and tab0.id_abogado is not null then 7
when tab0.version >=1 and tab0.id_abogado is null then 8
when tab0.version = 0 then 9

end AS ESTADO_PROCESO

from co_estudios_previos_v tab0
left join co_aprueba_ep tab1 ON tab1.id_estudios_previos = tab0.id_estudios_previos
left join co_aprueba_comite tab2 ON tab2.id_estudios_previos = tab0.id_estudios_previos
left join co_seleccion_ep tab3 ON tab3.id_estudios_previos = tab0.id_estudios_previos
left join co_contrato_v tab4 ON tab4.ID_SELECCION_EP = tab3.ID_SELECCION_EP
left join co_legaliza_contrato tab5 ON tab5.id_contrato = tab4.id_contrato
left join RPS_V tab6 ON tab6.ID = tab5.ID_RP

LEFT JOIN(
select tab0.ID_ESTUDIOS_PREVIOS, listagg(tab1.CDP,', ') within group( order by tab1.CDP ) AS CDPS
from CO_CDPS_EP tab0
left join CO_CDPS_V tab1 ON tab1.id = tab0.ID_CDP
group by tab0.ID_ESTUDIOS_PREVIOS

)tab7 ON tab7.id_estudios_previos = tab0.id_estudios_previos

)tab0

where tab0.id_anhos = $id_anhos and tab0.estado = 1
$whereAbogado
$whereArea
$whereEstadoProceso
$whereModalidad
$whereProceso
$whereResponsable
$whereSupervisor

order by tab0.MODALIDAD,tab0.PROCESO,tab0.version
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_terminacion_contrato] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
